package virtbuf

// functions to import and export the protobuf
// data to and from config files

import (
	"fmt"
	"os"
	"path/filepath"

	"google.golang.org/protobuf/encoding/protojson"
	"google.golang.org/protobuf/encoding/prototext"
	"google.golang.org/protobuf/reflect/protoreflect"
)

// writes out the cluster information it seperate files
// to make it humanly possible to hand edit things as needed
func (c *Cluster) ConfigSave() error {
	var d *Droplets
	d = new(Droplets)
	d.Droplets = c.Droplets
	if err := ConfigWriteJSON(d, "newdroplets.json"); err != nil {
		fmt.Println("droplets.json write failed")
		return err
	}
	if err := ConfigWriteTEXT(d, "newdroplets.text"); err != nil {
		fmt.Println("droplets.json write failed")
		return err
	}

	var h *Hypervisors
	h = new(Hypervisors)
	h.Hypervisors = c.Hypervisors
	if err := ConfigWriteJSON(h, "newhypervisors.json"); err != nil {
		fmt.Println("hypervisors.json write failed")
		return err
	}
	if err := ConfigWriteTEXT(h, "newhypervisors.text"); err != nil {
		fmt.Println("hypervisors.json write failed")
		return err
	}

	var e *Events
	e = new(Events)
	e.Events = c.Events
	if err := ConfigWriteJSON(h, "newEvents.json"); err != nil {
		fmt.Println("newEvents.json write failed")
		return err
	}
	if err := ConfigWriteTEXT(h, "newEvents.text"); err != nil {
		fmt.Println("newEvents.json write failed")
		return err
	}

	if err := ConfigWriteTEXT(c, "newCluster.text"); err != nil {
		fmt.Println("newCluster.json write failed")
		return err
	}

	var newc Cluster
	newc.Dirs = c.Dirs
	newc.Droplets = nil
	newc.Hypervisors = nil
	newc.Events = nil
	if err := ConfigWriteTEXT(&newc, "newSmallCluster.text"); err != nil {
		fmt.Println("newSmallCluster.json write failed")
		return err
	}

	return nil
}

func (c *Cluster) ConfigLoad() error {
	if c == nil {
		c = new(Cluster)
	}
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "newCluster.json")
	data, err := os.ReadFile(fullname)
	if err != nil {
		// log.Info("open config file :", err)
		return err
	}
	return c.UnmarshalJSON(data)
}

// reads in from the prototext file
// prototext file formats are not garrenteed to be stable. todo: hammer that out

func ConfigWriteJSON(a any, filename string) error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), filename)
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	msg, ok := a.(protoreflect.ProtoMessage)
	if !ok {
		return fmt.Errorf("provided value does not implement protoreflect.ProtoMessage")
	}
	text := protojson.Format(msg)
	fmt.Fprintln(cfgfile, text)
	return nil
}

func ConfigWriteTEXT(a any, filename string) error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), filename)
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	msg, ok := a.(protoreflect.ProtoMessage)
	if !ok {
		return fmt.Errorf("provided value does not implement protoreflect.ProtoMessage")
	}
	text := prototext.Format(msg)
	fmt.Fprintln(cfgfile, text)
	return nil
}

func WriteConfig(d *Droplets, h *Hypervisors, e *Events) bool {
	if !d.WriteConfigJSON() {
		return false
	}
	if !d.WriteConfigTEXT() {
		return false
	}

	if err := e.WriteConfigJSON(); err != nil {
		return false
	}
	if err := e.WriteConfigTEXT(); err != nil {
		return false
	}
	return true
}


// read in events.json
func ReadEventsConfig() (*Events, error) {
	e := new(Events)
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.json")
	data, err := os.ReadFile(fullname)
	if err != nil {
		// log.Info("open config file :", err)
		return nil, err
	}
	err = e.UnmarshalJSON(data)
	if err != nil {
		// log.Info("read json failed", err)
		return nil, err
	}

	return e, nil
}

// export as json
func (e *Events) WriteConfigJSON() error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.json")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	text := e.FormatJSON()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return nil
}

// export as prototext
func (e *Events) WriteConfigTEXT() error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.text")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	text := e.FormatTEXT()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return nil
}

// export as json
func (d *Droplets) WriteConfigJSON() bool {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "droplets.json")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return false
	}
	text := d.FormatJSON()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return true
}

// export as prototext
func (d *Droplets) WriteConfigTEXT() bool {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "droplets.text")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return false
	}
	text := d.FormatTEXT()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return true
}

// human readable JSON
func (c *Cluster) FormatJSON() string {
	return protojson.Format(c)
}

func (d *Droplets) FormatJSON() string {
	return protojson.Format(d)
}

func (d *Droplet) FormatJSON() string {
	return protojson.Format(d)
}

func (e *Events) FormatJSON() string {
	return protojson.Format(e)
}

func (h *Hypervisors) FormatJSON() string {
	return protojson.Format(h)
}

// apparently this isn't supposed to be used?
// https://protobuf.dev/reference/go/faq/#unstable-text
// this is a shame because this is much nicer output than JSON Format()
func (c *Cluster) FormatTEXT() string {
	return prototext.Format(c)
}

func (d *Droplets) FormatTEXT() string {
	return prototext.Format(d)
}

func (e *Events) FormatTEXT() string {
	return prototext.Format(e)
}

// marshal
func (c *Cluster) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(c)
}

func (d *Droplets) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(d)
}

func (e *Events) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(e)
}

// unmarshal
func (c *Cluster) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, c)
}

func (d *Droplets) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, d)
}

func (e *Events) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, e)
}
